package de.steinwedel.millstone.example;

import org.millstone.base.Application;
import org.millstone.base.ui.*;

public class SimpleCalc extends Application implements Button.ClickListener {
	
	private TextField value1;
	private TextField value2;
	private Select operator;
	private Button calculate;
	private TextField result;
	
	public void init() {
		// Erzeuge Widgets
		value1 = new TextField();
		value2 = new TextField();		
		operator = new Select();
		operator.addItem("+");
		operator.addItem("-");
		operator.addItem("*");
		operator.addItem("/");
		calculate = new Button("=", this);
		calculate.dependsOn(value1);
		calculate.dependsOn(value2);
		calculate.dependsOn(operator);
		result = new TextField();
		
		// Festlegen des Layouts im Dialogfenster; dabei wird ein 
		// Gitterlayout mit fnf Spalten und einer Zeile gewhlt; 
		// jedes Widget wird in einer eigenen Zelle platziert
		GridLayout layout = new GridLayout(5, 1);
		layout.addComponent(value1, 0, 0);
		layout.addComponent(value2, 2, 0);
		layout.addComponent(operator, 1, 0);
		layout.addComponent(calculate, 3, 0);
		layout.addComponent(result, 4, 0);		
		Window main = new Window("Simple Calculator with Millstone", layout);
		setMainWindow(main);
	}
	
	// Hier werden eingehende Events verarbeitet
	public void buttonClick(Button.ClickEvent event) {
		// Berechne Ergebnis
		try {
			float v1 = Float.parseFloat(value1.getValue().toString());
			float v2 = Float.parseFloat(value2.getValue().toString());
			float r;
			switch (operator.getValue().toString().charAt(0)) {
				case '-':
					r = v1 - v2;
					break;
				case '*':
					r = v1 * v2;
					break;
				case '/':
					r = v1 / v2;
					break;
				default:
					r = v1 + v2;
			}
			result.setValue(Float.toString(r));
		} catch (Exception e) {
			result.setValue("Fehlerhafte Eingabe!");
		}
	}

}
